import { ofType } from 'redux-observable';
import { concat, EMPTY, of, timer } from 'rxjs';
import { debounce, switchMap } from 'rxjs/operators';

import { GET_XRAY_LINE_ITEM_BRAND_SAFETY_OPTIONS } from '@/graphql/services/xRayLineItems/constants';

import { PAYLOAD_NAME } from '@/graphql/services/xRayLineItems/types/payload/brandSafety';

import { getBrandSafetyOptionsAction, setAction } from '../slices';
import { gqlRequest } from '@/modules/@common/request';

const query = `
  query ${GET_XRAY_LINE_ITEM_BRAND_SAFETY_OPTIONS}($payload: ${PAYLOAD_NAME}) {
    ${GET_XRAY_LINE_ITEM_BRAND_SAFETY_OPTIONS}(payload: $payload) {
      records {
        id
        name
     }   
    }
  }
`;

const getResponse = ({ data }) =>
  data[GET_XRAY_LINE_ITEM_BRAND_SAFETY_OPTIONS].records.map((o) => ({
    label: o.name,
    value: o.id,
  }));

export default (action$) =>
  action$.pipe(
    ofType(getBrandSafetyOptionsAction.type),
    debounce((action) => {
      const search = action.payload;
      return timer(search?.length > 1 ? 1000 : 0);
    }),
    switchMap((action) => {
      const stream$ = gqlRequest({
        query,
        variables: {
          payload: {
            searchText: action.payload ?? '',
            pageSize: 30,
          },
        },
      }).pipe(
        switchMap((response) => {
          if (!response.errors.length) {
            return of(
              setAction({
                brandSafetyOptions: getResponse(response),
              }),
            );
          }

          return EMPTY;
        }),
      );

      return concat(stream$);
    }),
  );
